﻿Barrel = LibStub("AceAddon-3.0"):NewAddon("Barrel", "AceConsole-3.0", "AceEvent-3.0")
local ldb = LibStub("LibDataBroker-1.1")
local db_icon = LibStub("LibDBIcon-1.0")
local L = LibStub("AceLocale-3.0"):GetLocale("Barrel")
local options = {}
local dataObjects = {}

function Barrel:OnInitialize()
	self:Config()
	options = LibStub("AceConfigRegistry-3.0"):GetOptionsTable("Barrel", "dialog", "Barrel-0.3")
	self:RegisterChatCommand("br", "ChatCommand")
	self:RegisterChatCommand("Barrel", "ChatCommand")
end

function Barrel:OnEnable()
	for name, dataobj in ldb:DataObjectIterator() do
		self:LibDataBroker_DataObjectCreated(nil, name, dataobj)
	end
	ldb.RegisterCallback(self, "LibDataBroker_DataObjectCreated")
end

function Barrel:LibDataBroker_DataObjectCreated(event, name, dataobj)
	if not dataobj.icon then
		dataobj.icon = ""
	end
	
	-- ripped from Fortress
	-- support data objects without type set, allthough that's not correct
	local t = dataobj.type
	if t and (t ~= "data source" and t ~= "launcher") then
		return
	end
	
	self:CreateDataObject(name, dataobj)
	
end

function Barrel:CreateDataObject(name, dataobj)
	if dataObjects[name] then return end
	
	dataObjects[name] = dataobj
	self:CreateMenu(name)
	if not self.db.profile[name] then self.db.profile[name] = {} end
	db_icon:Register("Barrel_"..name, dataobj, self.db.profile[name])
	
	if not self.db.profile[name].hide then
		self:EnableDataObject(name)
	end
end

function Barrel:EnableDataObject(name)
	local dataobj = dataObjects[name]
	if dataobj.type == "launcher" and self.db.profile.ignoreLaunchers or
		dataobj.icon == nil then
		return
	end
	db_icon:Show("Barrel_"..name)
end

function Barrel:DisableDataObject(name)
	db_icon:Hide("Barrel_"..name)
end

-- another rip from Fortress
function Barrel:ToggleLaunchers()
	local func = self.db.profile.ignoreLaunchers and self.DisableDataObject or self.EnableDataObject
	for name, obj in pairs(dataObjects) do
		if obj.type == "launcher" then
			func(self, name)
		end
	end
end
function Barrel:ToggleNonLaunchers()
	local func = self.db.profile.ignoreNonLaunchers and self.DisableDataObject or self.EnableDataObject
	for name, obj in pairs(dataObjects) do
		if obj.type ~= "launcher" then
			func(self, name)
		end
	end
end

function Barrel:ChatCommand(input)
	if not input or input:trim() == "" then
		LibStub("AceConfigDialog-3.0"):Open("Barrel")
	else
		LibStub("AceConfigCmd-3.0").HandleCommand(Barrel, "br", "Barrel", input)
	end
end

-- Copyright 2008, 2009 Copystring"
